package encapsulation;

import java.util.Set;

/**
 * Entity class, represents any entity in the program
 * @author Janina Voigt
 *
 */
public interface Entity {

	/**
	 * Gets the name of the entity
	 * @return the name of the entity
	 */
	public String getName();
	
	/**
	 * Gets all members of the entity
	 * @return all members of the entity
	 */
	public Set<Member> getMembers();
	
	/**
	 * Gets all accesses to members of the entity
	 * @return all accesses to members
	 */
	public Set<Access> getAccesses();
	
}
