package encapsulation;

/**
 * Measurement class, represents a single metrics measurement
 * @author Janina Voigt
 *
 */
public class Measurement {

	private String name;	//the name of the metric
	private String value;	//the value of the measurement
	private Entity entity;	//the entity that was measured
	
	/**
	 * Constructor for Measurement objects
	 * @param theName the name of the metric
	 * @param theValue the value of the measurement
	 * @param theEntity the entity that was measured
	 */
	public Measurement(String theName, String theValue, Entity theEntity){
		name = theName;
		value = theValue;
		entity = theEntity;
	}
	
	/**
	 * Gets the name of the metric being measured
	 * @return the name of the metric
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gets the value of the measurement
	 * @return the value of the measurement
	 */
	public String getValue() {
		return value;
	}
	
	/**
	 * Gets the entity the measurement applies to
	 * @return the entity the measurement applies to
	 */
	public Entity getEntity() {
		return entity;
	}
}
