package encapsulation;

import jst.symtab.*;

/**
 * Method class, represents a method in the program
 * @author Janina Voigt
 *
 */
public class Method extends AccessibleMember {

	private MethodDecl method;
	
	/**
	 * Constructor for Method objects
	 * @param theOwner the owner class or interface
	 * @param theMethod the JST MethodDecl corresponding to this method
	 */
	public Method(ClassOrInterface theOwner, MethodDecl theMethod) {
		super(theOwner);
		method = theMethod;
	}
	
	/**
	 * Gets the JST Decl corresponding to this member
	 * @return the JST Decl
	 */
	public Decl getDecl() {
		return method;
	}
	
	/**
	 * Returns boolean indicating if the member is a method 
	 * @return true if the member is a method, false otherwise
	 */
	public boolean isMethod() {
		return true;
	}
}
