
package jst.symtab;

import java.util.*;
import java.io.*;
import java.lang.reflect.Modifier;

import jst.parsetree.*;
import jst.symtab.visitor.ModelVisitor;

public class ParameterDecl extends VariableDecl {

	protected int modifier; // Parameters may be final

	public ParameterDecl(OperationDecl ownerOperation, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerOperation, theSimpleName, theSource);

    	ownerOperation.addParameter(this);
    }

	public ParameterDecl(CatchBlock ownerCatchBlock, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerCatchBlock, theSimpleName, theSource);

    	ownerCatchBlock.setParameter(this);
    }

	public ParameterDecl(OperationDecl newOwnerOperation, ParameterDecl that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerOperation, that, swaps);
	}

	public ParameterDecl(CatchBlock newOwnerCatchBlock, ParameterDecl that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerCatchBlock, that, swaps);
	}

	public void copy(OperationDecl newOwnerOperation, Map<TypeParameter, ActualType> swaps) {
		new ParameterDecl(newOwnerOperation, this, swaps);
	}

	public void copy(CatchBlock newOwnerCatchBlock, Map<TypeParameter, ActualType> swaps) {
		new ParameterDecl(newOwnerCatchBlock, this, swaps);
	}

	public String getCanonicalName() {
    	return "PRM_" + getOwnerScope().getCanonicalName().substring(4) + "." + simpleName;
    }

	public int getModifier() {
    	return modifier;
    }

	public void setModifier(int theModifier) {
    	modifier = theModifier;
    }

    public void accept(ModelVisitor visitor) {
        visitor.visitParameterDecl(this);
    }
}
