package jst.symtab.link;

import jst.app.JSTMessage;
import jst.symtab.*;

public class ClassTypeLookup extends UserTypeLookup {
	
	public ClassTypeLookup(ScopeLink theQualifier, Identifier name) {
		super(theQualifier, name);
	}
	
	// Copy constructor to convert UserTypeLookup that turned out to be a class
	// into a ClassTypeLookup.  Needed for anonymous inner classes that can subtype
	// an interface or a class.
	public ClassTypeLookup(UserTypeLookup that) {
		this(that.qualifier, that.id);
	}

	public ClassTypeLookup(Decl newOwner, ClassTypeLookup that) {
		super(newOwner, that);
	}

	public ClassTypeLookup copy(Decl newOwner) {
		return new ClassTypeLookup(newOwner, this);
	}

	protected boolean checkType() {
		return getClassType() != null;
	}

	public ClassType getClassType() {
		if (type == null)
			return  null;

		UserType userType = type.asUserType();
		if (userType == null)
			return null;

		return userType.asClass();
	}

	protected JSTMessage getTypeError() {
		return JSTMessage.TYPE_NOT_A_CLASS;
	}
}
