package jst.symtab.link;

import parser.parsetree.SyntaxTreeLeaf;
import jst.app.JSTMessage;
import jst.symtab.*;

public class CombinedTypeLink implements TypeLink {

	protected TypeLink typeLink1;

	protected TypeLink typeLink2;

	public CombinedTypeLink(TypeLink type1, TypeLink type2) {

		typeLink1 = type1;
		typeLink2 = type2;

		assert typeLink1 != null;
		assert typeLink2 != null;
	}

	public CombinedTypeLink(Decl newOwner, CombinedTypeLink that) {
		typeLink1 = that.typeLink1.copyType(newOwner);
		typeLink2 = that.typeLink2.copyType(newOwner);
	}

	public CombinedTypeLink copy(Decl newOwner) {
		return new CombinedTypeLink(newOwner, this);
	}

	public CombinedTypeLink copyType(Decl newOwner) {
		return copy(newOwner);
	}
	public String getName() {
		return typeLink1.getName() + "/" + typeLink2.getName();
	}

	public int getLine() {
		return typeLink1.getLine();
	}

	public int getColumn() {
		return typeLink1.getColumn();
	}

	public String getOwnerFileName() {
		return typeLink1.getOwnerFileName();
	}

	public String getFullName() {
		return typeLink1.getFullName();
	}

	public boolean resolve() {
		return typeLink1.resolve() && typeLink2.resolve();
	}

	public JSTMessage getMessage() {
		if (typeLink1.getType() == null)
			return typeLink1.getMessage();

		return typeLink2.getMessage();
	}

	public Decl getDecl() {
		return getType();
	}
	
	public SyntaxTreeLeaf getSource(){
		return null;
	}

	public TypeDecl getType() {

		TypeDecl lType = typeLink1.getType();
		TypeDecl rType = typeLink2.getType();

		// Temporary hack!  Use lType.
		return lType;

		/*
		// If the second and third operands have the same type (which may be the null type),
        // then that is the type of the conditional expression.
		if (lType == rType)
        	return lType;

		// If one of the second and third operands is of type boolean and the type of the
		// other is of type Boolean, then the type of the conditional expression is boolean.
		if (lType == PrimitiveType.BooleanType && rType.getCanonicalName() == "java.lang.Boolean")
			return PrimitiveType.BooleanType;

		if (lType.getCanonicalName() == "java.lang.Boolean" && rType == PrimitiveType.BooleanType && )
			return PrimitiveType.BooleanType;

		// If one of the second and third operands is of the null type and the type of the other is
        // a reference type, then the type of the conditional expression is that reference type.
        if (lType == NullType.getNullType() && rType instanceof ReferenceType)
			return rType;

        if (lType instanceof ReferenceType && rType == NullType.getNullType())
			return lType;


		Blarg!  Need the actual literal constant!




		if (PrimitiveType.isNumeric(lType) && PrimitiveType.isNumeric(rType)) {
        	// Otherwise, if the second and third operands have numeric type, then there are several cases:

			// If one of the operands is of type byte and the other is of type short,
			// then the type of the conditional expression is short.
        	if (lType == PrimitiveType.ByteType && rType == PrimitiveType.ShortType)
				return PrimitiveType.ShortType;

            if (lType == PrimitiveType.ShortType && rType == PrimitiveType.ByteType)
                 return PrimitiveType.ShortType;

			// If one of the operands is of type T where T is byte, short, or char, and the other
            // operand is a constant expression of type int whose value is representable in type T,
            // then the type of the conditional expression is T.
        	if (lType == PrimitiveType.ByteType || lType == PrimitiveType.ShortType || lType == PrimitiveType.CharType)
            	if (isSmallIntConst(innerConditionalExpression)) {
                	extractedType = lType;
					return;
                }

        	if (rType == PrimitiveType.ByteType || rType == PrimitiveType.ShortType || rType == PrimitiveType.CharType)
            	if (isSmallIntConst(expression)) {
                	extractedType = rType;
                    return;
                }

			// Otherwise, binary numeric promotion (5.6.2) is applied to the operand types, and
            // the type of the conditional expression is the promoted type of the second and third
            // operands.
            extractedType = binaryNumericPromotion(lType, rType);
        }

		// If one of the second and third operands is of the null type and the type of the other is
        // a reference type, then the type of the conditional expression is that reference type.
        if (lType == NullType.getNullType() && rType != NullType.getNullType())
        	if (rType instanceof ReferenceType) {
				extractedType = rType;
				return;
			}

        if (lType != NullType.getNullType() && rType == NullType.getNullType())
        	if (lType instanceof ReferenceType) {
				extractedType = lType;
				return;
			}

		// If the second and third operands are of different reference types, then it must be
        // possible to convert one of the types to the other type (call this latter type T) by
        // assignment conversion (5.2); the type of the conditional expression is T. It is a
        // compile-time error if neither type is assignment compatible with the other type.
       	if (lType instanceof ReferenceType && rType instanceof ReferenceType) {
        	if (lType.assignableFrom(rType)) {
				extractedType = lType;
				return;
			}
        	if (rType.assignableFrom(lType)) {
				extractedType = rType;
				return;
			}
        }

		// Error.	
		*/
	}
}
