package jst.symtab.visitor;
import jst.symtab.*;
import java.io.PrintWriter;
import java.util.*;
import java.lang.reflect.Modifier;

public class NOMVisitor extends CompositionVisitor {

    protected Map counts;

    public NOMVisitor() {
        counts = new HashMap();
    }

    public void visitMethodDecl(MethodDecl methodDecl) {
        Scope owner = methodDecl.getOwnerScope();
        Integer count = (Integer) counts.get(owner);
        if (count == null)
            count = new Integer(1);
        else
            count = new Integer(count.intValue() + 1);

        counts.put(owner, count);
    }

    public Map getResult() {
        return counts;
    }
}
