package jst.symtab.visitor;

import java.util.*;

import jst.app.JSTMessage;
import jst.symtab.*;
import jst.parsetree.*;

public class ReferenceResolver extends CompositionVisitor {

    protected List<JSTMessage> messages;

    public ReferenceResolver() {
        messages = new ArrayList<JSTMessage>();
    }

    public void visitPackageDecl(PackageDecl packageDecl) {
		// Omit SourceFiles.
        visitKids(packageDecl.getTypes());
        visitKids(packageDecl.getSubPackages());
    }

    public void visitExecutableCode(ExecutableCode executableCode) {
		executableCode.resolveReferences(messages);

        super.visitExecutableCode(executableCode);
    }

	public List getMessages() {
		return messages;
	}
}
