package parser.grammar;

/** Represents a terminal in a grammar. */
public class Terminal extends Symbol implements ShiftOrReduce {

    /**
     * Construct a Terminal with the given name.
     *
     * @param theName describes this Terminal -- usually matching the literal text of a token.
     */
    public Terminal(String theName) {
	    this(theName, 0);
	}

    public Terminal(String theName, int theID) {
	    super(theName, theID);
	}

    /**
     * Is this a Terminal?
     *
     * @return true, always.
     */
	public boolean isTerminal() {
		return true;
	}

    public Terminal asTerminal() {
        return this;
    }

    public boolean isShift() {
        return true;
    }

    public Terminal asShift() {
        return this;
    }

    public Nonterminal asGoto() {
        return null;
    }

    public Production asReduce() {
        return null;
    }
}
