package parser.parsetree;

import parser.grammar.*;
import parser.parsetree.visitor.*;

/** Abstract superclass for a lexeme found in a source file. */
public interface SyntaxTreeLeaf extends SyntaxTree {

    /** Getter for terminalType. */
    public Terminal getTerminalType();

    /** Does token carry a separate value? */
    public boolean hasValue();

    /** Set the successor to this token. */
	public void setNext(SyntaxTreeLeaf theNext);

    /** Getter for next. */
    public SyntaxTreeLeaf getNext();
}
