package parser.parsetree.treeFactory;

import parser.parsetree.*;
import parser.grammar.*;

import java.util.*;

/** Factory for parse tree and AST branches. */
public interface SyntaxTreeFactory {

    /**
     * Create a branch node.
     *
     * @param type the Type of production recognised.
     * @param kids the child nodes of this branch.
     * @return a new branch node.
     */
    public SyntaxTreeBranch makeBranch(Production type, List kids);

    public void makeAmbiguity(SyntaxTreeBranch existing, SyntaxTreeBranch alternative);
}
