package parser.pda.stateMachine;
import parser.parsetree.*;
import java.util.*;
import parser.pda.tokenStream.*;
import parser.grammar.*;
import parser.pda.*;
import parser.pda.PdaActor;

public class OneLookahead extends AbstractLookahead {

    protected Map actions; // TerminalSymbol ==> ShiftOrReduce

    public OneLookahead() {
        actions = new HashMap();
    }

    public void addAction(Terminal on, ShiftOrReduce action) {
        assert on != null && action != null;

        Object old = actions.put(on, action);

        assert old == null : "Conflict on " + on + " actions: " + old + ", " + action;
    }

    public void act(Looker input, PdaActor pda){
        Terminal terminal = input.look();
        ShiftOrReduce action = (ShiftOrReduce) actions.get(terminal);
        act(action, input, pda);
    }

    public Set getExpected() {
	    Set result = new HashSet();

		Iterator typeIter = actions.keySet().iterator();
		while (typeIter.hasNext()) {
			Terminal type = (Terminal) typeIter.next();
			List list = new ArrayList(1);
			list.add(type);
			result.add(list);
	    }

        return result;
	}

    public String toString() {
        return actions.toString();
    }
}
